package elog_gui ; 

require Exporter;   
@ISA = ('Exporter');

@EXPORT=qw(elog_gui_init elog_gui) ;

use Tk ;
use Tk::Toplevel ; 
use Tk::Message ; 
use Tk::Button ; 
use Tk::Frame ;

our (%Config, $Ok) ; 


sub mkfonts {
    $Config{MW}->fontCreate("ptkBold",  -family=>"Lucida",      -weight=>'bold',   -size=>14) ;
    $Config{MW}->fontCreate("ptkSmall", -family=>"Avant-garde", -weight=>'normal', -size=>10) ;
}

sub elog_gui_init {
    %Config = @_ ; 
    mkfonts() ;

    $Config{1}="Notify" ;
    $Config{2}="Complain" ;
    $Config{3}="Die" ;
    $Config{4}="Fault" ;
    $Config{5}="Debug" ;
    $Config{6}="Alert" ;

    $Config{icon_1}="info" ;
    $Config{icon_2}="error" ;
    $Config{icon_3}="error" ;
    $Config{icon_4}="error" ;
    $Config{icon_5}="info" ;
    $Config{icon_6}="warning" ;
}

sub elog_gui {
    my ($severity, $msg) = @_ ;
    my $result = 0 ;
    if ( $severity > 0 ) { 
	chomp $msg ;
	my @msg = split("\n", $msg) ; 
	while ( $msg[-1] =~ /^\s*$/ ) { 
	    pop(@msg) ; 
	}
	while ( $msg[0] =~ /^\s*$/ ) { 
	    shift(@msg) ; 
	}
	my $lines = @msg ; 
	if ( $lines > 30 ) { 
	    $lines = 30 ; 
	} 
	my $width = 0 ;
	foreach ( @msg ) { 
	    if ( length($_) > $width ) { 
		$width = length($_) ; 
	    }
	}
	if ( $width > 70 ) { 
	    $width = 70 ; 
	}
	my $w = $Config{MW}->Toplevel() ;
	my $title = $Config{$severity} ;
	$w->title($title) ;
	$w->iconname($title) ;
	my $bitmap = $Config{"icon_$severity"} ;
	my $f = $w->Frame()
	    ->pack(-side=>"top", -fill=>"both", -expand=>"yes") ;
	my $label = $f->Label(-bitmap=>$bitmap) 
	    ->pack(-side=>"left", -padx=>10, -fill=>"y") ; 

	my $text = $f->Scrolled("Text",
	    -font=>"ptkBold",
	    -relief=>"flat",
	    -height=>$lines,
	    -width=>$width,
	    -scrollbars=>"osoe",
	    ) ->pack(-side=>"left", -fill=>"both", -expand=>"yes") ;
	$text->insert("end", join("\n", @msg)) ;
	$text->see("end") ;

	$w->Button(-text=>"Dismiss", -font=>"ptkSmall",
		-command=>sub { $w->destroy } )
	    ->pack(-side=>"top", -fill=>"x") ;
	    # ->pack(-side=>"top", -fill=>"x", -expand=>"yes") ;

	$w->update() ;
	my $x = int($Config{MW}->rootx + ($Config{MW}->width() - $w->reqwidth())/2) ;
	$x = 0 if $x < 0 ;
	my $y = $Config{MW}->rooty + 20 ;
	$w->geometry("+$x+$y") ;
	$w->minsize($w->reqwidth(), $w->reqheight()) ;
	$w->waitWindow() ;
	$result = 1 ;
    }
    return $result ;
}

1;
